> ## Documentation Index
> Fetch the complete documentation index at: https://docs.debridge.com/llms.txt
> Use this file to discover all available pages before exploring further.

# This endpoint returns the data for a transaction to place a cross-chain DLN order.

> This endpoint returns the data for a transaction to place a cross-chain DLN order.



## OpenAPI

````yaml /dln-details/swagger/create-tx.json get /v1.0/dln/order/create-tx
openapi: 3.0.0
info:
  title: deBridge Liquidity Network (DLN) API
  description: >-
    A turnkey solution for a high-performance cross-chain trading<br><br><a
    href="https://docs.debridge.finance/dln-the-debridge-liquidity-network-protocol/interacting-with-the-api/quick-start-guide">Quick
    Start Guide</a>
  version: 1.0.0
  contact: {}
  termsOfService: https://app.debridge.finance/assets/files/DLN-TermsOfService.pdf
servers:
  - url: https://dln.debridge.finance
security: []
tags: []
externalDocs:
  description: DLN API documentation
  url: >-
    https://docs.debridge.finance/dln-the-debridge-liquidity-network-protocol/introduction
paths:
  /v1.0/dln/order/create-tx:
    get:
      tags:
        - DLN
      summary: >-
        This endpoint returns the data for a transaction to place a cross-chain
        DLN order.
      description: >-
        This endpoint returns the data for a transaction to place a cross-chain
        DLN order.
      operationId: DlnOrderControllerV10_createOrder
      parameters:
        - name: srcChainId
          required: true
          in: query
          description: >-
            An ID of a source chain, a chain where the cross-chain swap will
            start
          example:
            '1':
              summary: Ethereum
              value: '1'
            '10':
              summary: Optimism
              value: '10'
            '56':
              summary: BNB Chain
              value: '56'
            '137':
              summary: Polygon
              value: '137'
            '8453':
              summary: Base
              value: '8453'
            '42161':
              summary: Arbitrum One
              value: '42161'
            '43114':
              summary: Avalanche
              value: '43114'
            '59144':
              summary: Linea
              value: '59144'
            '7565164':
              summary: Solana
              value: '7565164'
            '100000001':
              summary: Neon
              value: '100000001'
            '100000002':
              summary: Gnosis
              value: '100000002'
            '100000008':
              summary: Zilliqa
              value: '100000008'
            '100000009':
              summary: Flow
              value: '100000009'
            '100000013':
              summary: Story
              value: '100000013'
            '100000014':
              summary: Sonic
              value: '100000014'
            '100000017':
              summary: Abstract
              value: '100000017'
            '100000019':
              summary: Cronos
              value: '100000019'
            '100000020':
              summary: Berachain
              value: '100000020'
            '100000021':
              summary: Bob
              value: '100000021'
            '100000022':
              summary: HyperEVM
              value: '100000022'
            '100000023':
              summary: Mantle
              value: '100000023'
            '100000025':
              summary: Sophon
              value: '100000025'
            '100000026':
              summary: Tron
              value: '100000026'
            '100000027':
              summary: Sei
              value: '100000027'
            '100000028':
              summary: Plasma
              value: '100000028'
            '100000029':
              summary: Injective
              value: '100000029'
            '100000030':
              summary: Monad
              value: '100000030'
            '100000031':
              summary: Megaeth
              value: '100000031'
          schema:
            type: string
            enum:
              - '1'
              - '10'
              - '56'
              - '137'
              - '8453'
              - '42161'
              - '43114'
              - '59144'
              - '7565164'
              - '100000001'
              - '100000002'
              - '100000008'
              - '100000009'
              - '100000013'
              - '100000014'
              - '100000017'
              - '100000019'
              - '100000020'
              - '100000021'
              - '100000022'
              - '100000023'
              - '100000025'
              - '100000026'
              - '100000027'
              - '100000028'
              - '100000029'
              - '100000030'
              - '100000031'
        - name: srcChainTokenIn
          required: true
          in: query
          description: An address (on a source chain) of an input token to swap
          example:
            native:
              summary: Native coin (e.g., ETH on Ethereum, BNB on BNB Chain)
              value: '0x0000000000000000000000000000000000000000'
            usdt:
              summary: USDT token on Ethereum
              value: '0xdAC17F958D2ee523a2206206994597C13D831ec7'
            native_solana:
              summary: Native token on SOLANA
              value: '11111111111111111111111111111111'
            usdc_solana:
              summary: USDC token on SOLANA
              value: EPjFWdd5AufqSSqeM2qN1xzybapC8G4wEGGkZwyTDt1v
            native_tron:
              summary: Native token on Tron
              value: T9yD14Nj9j7xAB4dbGeiX9h8unkKHxuWwb
            usdt_tron:
              summary: USDT token on Tron
              value: TR7NHqjeKQxGTCi8q8ZY4pL8otSzgjLj6t
          schema:
            type: string
        - name: srcChainTokenInAmount
          required: true
          in: query
          description: An amount of input tokens to swap
          example:
            eth:
              summary: 0.1 ETH (decimals=18)
              value: '100000000000000000'
            usdt:
              summary: 50 USDT (decimals=6)
              value: '50000000'
            busd:
              summary: 50 BUSD (decimals=18)
              value: '50000000000000000000'
            usdc:
              summary: 50 USDC (decimals=6)
              value: '50000000'
            sol:
              summary: 0.1 SOL (decimals=9)
              value: '100000000'
            trx:
              summary: 1 TRX (decimals=6)
              value: '1000000'
            recomended:
              summary: Use a recommended srcChainTokenInAmount calculated upon request
              value: auto
            max:
              summary: >-
                Use a maximum possible srcChainTokenInAmount calculated upon
                request
              value: max
          schema:
            type: string
        - name: dstChainId
          required: true
          in: query
          description: >-
            An ID of a destination chain, a chain where the cross-chain swap
            will finish. Must differ from `srcChainId`!
          example:
            '1':
              summary: Ethereum
              value: '1'
            '10':
              summary: Optimism
              value: '10'
            '56':
              summary: BNB Chain
              value: '56'
            '137':
              summary: Polygon
              value: '137'
            '8453':
              summary: Base
              value: '8453'
            '42161':
              summary: Arbitrum One
              value: '42161'
            '43114':
              summary: Avalanche
              value: '43114'
            '59144':
              summary: Linea
              value: '59144'
            '7565164':
              summary: Solana
              value: '7565164'
            '100000001':
              summary: Neon
              value: '100000001'
            '100000002':
              summary: Gnosis
              value: '100000002'
            '100000008':
              summary: Zilliqa
              value: '100000008'
            '100000009':
              summary: Flow
              value: '100000009'
            '100000013':
              summary: Story
              value: '100000013'
            '100000014':
              summary: Sonic
              value: '100000014'
            '100000017':
              summary: Abstract
              value: '100000017'
            '100000019':
              summary: Cronos
              value: '100000019'
            '100000020':
              summary: Berachain
              value: '100000020'
            '100000021':
              summary: Bob
              value: '100000021'
            '100000022':
              summary: HyperEVM
              value: '100000022'
            '100000023':
              summary: Mantle
              value: '100000023'
            '100000025':
              summary: Sophon
              value: '100000025'
            '100000026':
              summary: Tron
              value: '100000026'
            '100000027':
              summary: Sei
              value: '100000027'
            '100000028':
              summary: Plasma
              value: '100000028'
            '100000029':
              summary: Injective
              value: '100000029'
            '100000030':
              summary: Monad
              value: '100000030'
            '100000031':
              summary: Megaeth
              value: '100000031'
          schema:
            default: 56
            type: string
            enum:
              - '1'
              - '10'
              - '56'
              - '137'
              - '8453'
              - '42161'
              - '43114'
              - '59144'
              - '7565164'
              - '100000001'
              - '100000002'
              - '100000008'
              - '100000009'
              - '100000013'
              - '100000014'
              - '100000017'
              - '100000019'
              - '100000020'
              - '100000021'
              - '100000022'
              - '100000023'
              - '100000025'
              - '100000026'
              - '100000027'
              - '100000028'
              - '100000029'
              - '100000030'
              - '100000031'
        - name: dstChainTokenOut
          required: true
          in: query
          description: An address (on a destination chain) of a target token.
          example:
            busd:
              summary: BUSD token on BNB Chain
              value: '0xe9e7CEA3DedcA5984780Bafc599bD69ADd087D56'
            native:
              summary: Native coin (e.g., ETH on Ethereum, BNB on BNB Chain)
              value: '0x0000000000000000000000000000000000000000'
            native_solana:
              summary: Native token on SOLANA
              value: '11111111111111111111111111111111'
            usdc_solana:
              summary: USDC token on SOLANA
              value: EPjFWdd5AufqSSqeM2qN1xzybapC8G4wEGGkZwyTDt1v
            native_tron:
              summary: Native token on Tron
              value: T9yD14Nj9j7xAB4dbGeiX9h8unkKHxuWwb
            usdt_tron:
              summary: USDT token on Tron
              value: TR7NHqjeKQxGTCi8q8ZY4pL8otSzgjLj6t
          schema:
            type: string
        - name: dstChainTokenOutAmount
          required: false
          in: query
          description: >-
            Amount of the target asset the market maker expects to receive upon
            order fulfillment. This property can be set to "auto" so that the
            API will suggest the best possible outcome of the order based on
            current market conditions and the protocol fees, keeping the order
            in a reasonable-to-fullfill state
          example:
            recomended:
              summary: >-
                Use a recommended dstChainTokenOutAmount calculated upon request
                (default)
              value: auto
            eth:
              summary: 0.1 ETH (decimals=18)
              value: '100000000000000000'
            usdt:
              summary: 50 USDT (decimals=6)
              value: '50000000'
            busd:
              summary: 50 BUSD (decimals=18)
              value: '50000000000000000000'
            usdc:
              summary: 50 USDC (decimals=6)
              value: '50000000'
          schema:
            type: string
        - name: additionalTakerRewardBps
          required: false
          in: query
          description: >-
            `additionalTakerRewardBps` is additionally laid in on top of default
            taker margin.
          schema:
            type: integer
        - name: srcIntermediaryTokenAddress
          required: false
          in: query
          description: >-
            An address (on a source chain) of an intermediary token a user's
            input funds should be swapped to prior order creation. This token
            must be publicly traded and listed on major DEX aggregators.
            Examples: USDC on Ethereum, DAI on Ethereum, USDC on Solana. This
            property can be either a Circle-issued USDC token or ETH, or an
            arbitrary token; setting an arbitrary token also requires you to
            specify `dstIntermediaryTokenAddress`, `intermediaryTokenUSDPrice`
            and `dstIntermediaryTokenSpenderAddress`  properties as well.
          example:
            default: {}
            native:
              summary: Native coin (e.g., ETH on Ethereum, BNB on BNB Chain)
              value: '0x0000000000000000000000000000000000000000'
            usdt:
              summary: USDT token on Ethereum
              value: '0xdAC17F958D2ee523a2206206994597C13D831ec7'
            native_solana:
              summary: Native token on SOLANA
              value: '11111111111111111111111111111111'
            usdc_solana:
              summary: USDC token on SOLANA
              value: EPjFWdd5AufqSSqeM2qN1xzybapC8G4wEGGkZwyTDt1v
          schema:
            type: string
        - name: dstIntermediaryTokenAddress
          required: false
          in: query
          description: >-
            An address (on a destination chain) of an intermediary token whose
            value assumed to be equal to the value of
            `srcIntermediaryTokenAddress` . This token must be publicly traded
            and listed on major DEX aggregators.  Examples: USDC on Ethereum,
            DAI on Ethereum, USDC on Solana. Setting this property also requires
            you to specify `srcIntermediaryTokenAddress`,
            `intermediaryTokenUSDPrice` and `dstIntermediaryTokenSpenderAddress`
            properties as well.
          example:
            default: {}
            native:
              summary: Native coin (e.g., ETH on Ethereum, BNB on BNB Chain)
              value: '0x0000000000000000000000000000000000000000'
            usdt:
              summary: USDT token on Ethereum
              value: '0xdAC17F958D2ee523a2206206994597C13D831ec7'
            native_solana:
              summary: Native token on SOLANA
              value: '11111111111111111111111111111111'
            usdc_solana:
              summary: USDC token on SOLANA
              value: EPjFWdd5AufqSSqeM2qN1xzybapC8G4wEGGkZwyTDt1v
          schema:
            type: string
        - name: dstIntermediaryTokenSpenderAddress
          required: false
          in: query
          description: >-
            Applicable to a EVM-compatible destination chain. An address (on a
            EVM-compatible destination chain) assumed as a spender of the
            intermediary token (set as `dstIntermediaryTokenAddress`) during
            order fulfillment. This address must hold a reasonable amount (of at
            least $100 in value for testing purposes, or at least 10% of the
            average order value) of the given intermediary token, and issue
            on-chain approvals to spent the given  intermediary token by the two
            trusted DLN contracts (DlnDestination:
            {CURRENT_ENV[dstChain].pmmDst} and CrosschainForwarder:
            {CURRENT_ENV[dstChain].evm.forwarderContract}). This property is
            required when `srcIntermediaryTokenAddress` and
            `dstIntermediaryTokenAddress` are set.
          schema:
            type: string
        - name: intermediaryTokenUSDPrice
          required: false
          in: query
          description: >-
            A value (a spot price) of the given intermediary token expressed in
            US dollars. Keep in mind this price is not used to calculate the
            spread of an order, but only as a reference price for operating
            expenses incurred by a taker during and after order fulfillment. The
            order spread is still calculated using the market price quoted from
            a major DEX.
          schema:
            type: number
        - name: dstChainTokenOutRecipient
          required: false
          in: query
          description: >-
            Address (on the destination chain) where target tokens should be
            transferred to after the swap. **Required for transaction
            construction**, otherwise only the quote is returned!
          schema:
            type: string
        - name: senderAddress
          required: false
          in: query
          description: >-
            Address (on the source chain) who submits input tokens for a
            cross-chain swap
          schema:
            type: string
        - name: srcChainOrderAuthorityAddress
          required: false
          in: query
          description: >-
            Address (on the source chain) who submits input tokens for a
            cross-chain swap. **Required for transaction construction**,
            otherwise only the quote is returned!
          schema:
            type: string
        - name: srcAllowedCancelBeneficiary
          required: false
          in: query
          description: >-
            Fixed recipient of the funds of an order in case it is being
            cancelled. If not set, the recipient could be set later upon order
            cancellation.
          schema:
            type: string
        - name: referralCode
          required: false
          in: query
          description: >-
            Make sure you pass your referral code which can be generated here:
            https://app.debridge.finance/refer

            With your referral code, your address will earn an additional 25% of
            deBridge points
            (https://debridge.finance/blog/introducing-debridge-points/), on top
            of the points generated by users who engage in activity on deBridge
            through your referral.
          schema:
            type: number
        - name: affiliateFeePercent
          required: false
          in: query
          description: >-

            The share of the input amount to be distributed to the
            `affiliateFeeRecipient` (if given) address as an affiliate fee.




            If you are building on top of deSwap, you might want to take a small
            fee relative to the amount of a token a user provides for a swap. To
            achieve this, set this parameter to a desired % (e.g. `0.1` stands
            for 0.1%; the max value is `10` which stands for 10% of
            `srcAmountInParam`) and specify your wallet address in the
            `affiliateFeeRecipient` parameter.




            For example, setting this parameter to `0.1` means that when the
            user gives 5000 USDT then you will receive 5 USDT immediately after
            transaction is being confirmed.
                  
          example:
            no_fee:
              summary: No affiliate fee
              value: 0
            fee_0.1:
              summary: Set 0.1% affiliate fee
              value: 0.1
            fee_1:
              summary: Set 1% affiliate fee
              value: 1
          schema:
            type: number
        - name: affiliateFeeRecipient
          required: false
          in: query
          description: >-
            An address (on an origin chain) that will receive affiliate fees
            according to the `affiliateFeePercent` parameter.
          schema:
            type: string
        - name: srcChainTokenInSenderPermit
          required: false
          in: query
          description: >-
            Typically, a sender is required to approve token transfer to
            deBridge forwarder for further transfer and swap. For gas-less
            cases, a sender-signed permit message may be provided to be executed
            by deBridge forwarder before actual transfer.
          schema:
            type: string
        - name: dstChainOrderAuthorityAddress
          required: false
          in: query
          description: >-
            Address on the destination chain whom should be granted the
            privileges to manage the order (patch, cancel, etc). **Required for
            transaction construction**, otherwise only the quote is returned!
          schema:
            type: string
        - name: enableEstimate
          required: false
          in: query
          description: >-
            This flag forces deSwap API to validate the resulting transaction
            and estimate its gas consumption. You will find the estimation at
            `tx.gasLimit` field of the resulting object.


            **Important:** to estimate a transaction, you are required to fill
            the `senderAddress` property with the address that will be used to
            execute this transaction. It should have enough assets on its
            balance to cover the amount specified in the `srcChainTokenInAmount`
            property, and enough ether to cover the protocol global fixed fee.


            **Caution:** if the input token (`srcChainTokenIn`) is not a native
            blockchain currency but an ERC-20 token, it is necessary to provide
            an approve to spend this token by the `tx.allowanceTarget` contract
            prior to such estimation. This can be done either by executing
            `increaseAllowance()` on-chain or by providing the permit envelope
            via the `srcChainTokenInSenderPermit` property. Failing to provide a
            correct approve to spend will result an error during transaction.
          schema:
            type: boolean
        - name: allowedTaker
          required: false
          in: query
          description: An address (on a destination chain) of a allowed taker.
          schema:
            type: string
        - name: externalCall
          required: false
          in: query
          description: >-
            A stringified versioned JSON with data fields that form an encoded
            transaction call to be attached to a DLN order and would be executed
            upon order fulfillment on the destination chain. The following
            schemas are currently supported:
                
             - for Solana as a destination chain:
            `{
                "version": "solana_1",
                "fields": {
                    "calldata": "0x..."
                }
            }`
                
             - for EVM-compatible chains (gas optional):
            `{
                "version": "evm_1",
                "fields": {
                    "to": "0x...",
                    "data": "0x...",
                    "gas": 0
                }
            }`
                
          deprecated: true
          schema:
            type: string
        - name: dlnHook
          required: false
          in: query
          description: >
            JSON representing a DLN Hook to be attached to an order. Depending
            on the destination chain, the following templates are available:

                
             - for Solana as a destination chain:
            `{
                "type": "solana_serialized_instructions",
                "data": {
                  "instructions": "0x..."
                }
            }`

                
             - for EVM-based destination chains to make an arbitrary transaction call via the universal DLN hook:
            `{
                "type": "evm_transaction_call",
                "data": {
                  "to": "0x...", "
                  calldata": "0x...",
                  "gas": 0
                }
            }`

                
             - for EVM-based destination chains to attach an arbitrary hook:
            `{
              "type": "evm_hook_data_v1",
              "data": {
                "fallbackAddress": "0x...",
                "target": "0x...",
                "reward": "0",
                "isNonAtomic": false,
                "isSuccessRequired": false,
                "targetPayload": "0x"
               }
            }`
          schema:
            type: string
        - name: prependOperatingExpenses
          required: false
          in: query
          description: Tells API server to prepend operating expenses to the input amount
          schema:
            default: false
            type: boolean
        - name: metadata
          required: false
          in: query
          schema:
            type: string
        - name: otc
          required: false
          in: query
          description: >-
            Forces a P2P order where input and output tokens are left
            intact(renamed to ptp)
          deprecated: true
          schema:
            type: boolean
        - name: ptp
          required: false
          in: query
          description: Forces a P2P order where input and output tokens are left intact
          schema:
            type: boolean
        - name: skipSolanaRecipientValidation
          required: false
          in: query
          description: >-
            Skip system address validation `dstChainTokenOutRecipient` in
            Solana 
          schema:
            default: false
            type: boolean
        - name: srcChainPriorityLevel
          required: false
          in: query
          description: Configures the priority level for transaction fee estimation.
          schema:
            default: normal
            type: string
            enum:
              - normal
              - aggressive
      responses:
        '200':
          description: The request has succeeded
          content:
            application/json:
              schema:
                oneOf:
                  - $ref: '#/components/schemas/DlnOrderCreateTxResponse'
                  - $ref: '#/components/schemas/DlnOrderQuoteResponse'
        '400':
          description: >
            The request is malformed, has missing parameters, or has incorrect
            or contradicting parameter values. Possible error ids:

              
                    - INVALID_QUERY_PARAMETERS
              
              
                    - SOURCE_AND_DESTINATION_CHAINS_ARE_EQUAL
              
              
                    - AFFILIATE_FEE_PERCENT_NOT_SET
              
              
                    - AFFILIATE_FEE_RECIPIENT_NOT_SET
              
              
                    - ESTIMATION_FAILED
              
              
                    - ERROR_LOW_GIVE_AMOUNT
              
              
                    - UNSUPPORTED_TOKEN_IN
              
              
                    - UNSUPPORTED_TOKEN_OUT
              
              
                    - SENDER_ADDRESS_EMPTY
              
              
                    - IMPOSSIBLE_ROUTE
              
              
                    - INTERMEDIARY_TOKEN_NOT_FUNDED
              
              
                    - INTERMEDIARY_TOKEN_APPROVALS_MISSING
              
              
                    - INTERMEDIARY_TOKEN_NOT_CONFIGURED
              
              
                    - SAME_SOURCE_AND_DESTINATION_CHAINS
              
              
                    - UNABLE_TO_ESTIMATE_EXTERNAL_CALL_WITHOUT_GAS
              
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/BadRequestResponse'
        '500':
          description: >
            The server has encountered a situation it does not know how to
            handle. Possible error ids: 
              
                    - INTERNAL_SERVER_ERROR
              
              
                    - INTERNAL_SDK_ERROR
              
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/InternalServerErrorResponse'
components:
  schemas:
    DlnOrderCreateTxResponse:
      type: object
      properties:
        estimation:
          $ref: '#/components/schemas/DlnOrderEstimation'
        tx:
          $ref: '#/components/schemas/DlnTx'
        orderId:
          type: string
        prependedOperatingExpenseCost:
          type: string
        order:
          $ref: '#/components/schemas/Order'
        fixFee:
          type: string
        protocolFee:
          type: string
        protocolFeeApproximateUsdValue:
          type: string
        userPoints:
          type: number
        integratorPoints:
          type: number
        actualUserPoints:
          type: number
        actualIntegratorPoints:
          type: number
        estimatedTransactionFee:
          $ref: '#/components/schemas/FeeInfo'
        usdPriceImpact:
          type: object
      required:
        - estimation
        - tx
        - orderId
        - order
        - fixFee
        - userPoints
        - integratorPoints
    DlnOrderQuoteResponse:
      type: object
      properties:
        estimation:
          $ref: '#/components/schemas/DlnOrderEstimation'
        prependedOperatingExpenseCost:
          type: string
        tx:
          $ref: '#/components/schemas/TxQuote'
        order:
          $ref: '#/components/schemas/Order'
        fixFee:
          type: string
        protocolFee:
          type: string
        protocolFeeApproximateUsdValue:
          type: string
        userPoints:
          type: number
        integratorPoints:
          type: number
        actualUserPoints:
          type: number
        actualIntegratorPoints:
          type: number
        usdPriceImpact:
          type: object
      required:
        - estimation
        - order
        - fixFee
        - userPoints
        - integratorPoints
    BadRequestResponse:
      type: object
      properties:
        errorCode:
          type: integer
        errorId:
          type: string
          enum:
            - INVALID_QUERY_PARAMETERS
            - SOURCE_AND_DESTINATION_CHAINS_ARE_EQUAL
            - INCLUDED_GAS_FEE_NOT_COVERED_BY_INPUT_AMOUNT
            - INCLUDED_GAS_FEE_CANNOT_BE_ESTIMATED_FOR_TRANSACTION_BUNDLE
        errorMessage:
          type: string
        errorPayload:
          type: object
      required:
        - errorCode
        - errorId
        - errorMessage
        - errorPayload
    InternalServerErrorResponse:
      type: object
      properties:
        errorCode:
          type: integer
        errorId:
          type: string
          enum:
            - INTERNAL_SERVER_ERROR
            - INTERNAL_SDK_ERROR
        errorMessage:
          type: string
        errorPayload:
          type: object
      required:
        - errorCode
        - errorId
        - errorMessage
        - errorPayload
    DlnOrderEstimation:
      type: object
      properties:
        srcChainTokenIn:
          $ref: '#/components/schemas/SrcChainTokenInResponseType'
        srcChainTokenOut:
          $ref: '#/components/schemas/SrcChainTokenOutResponseType'
        dstChainTokenOut:
          $ref: '#/components/schemas/DstChainTokenOutResponseType'
        recommendedSlippage:
          type: number
        costsDetails:
          type: array
          items:
            $ref: '#/components/schemas/CostsDetailsProperty'
      required:
        - srcChainTokenIn
        - dstChainTokenOut
        - costsDetails
    DlnTx:
      type: object
      properties:
        to:
          type: string
        data:
          type: string
        value:
          type: string
        gasLimit:
          type: number
      required:
        - to
        - data
        - value
    Order:
      type: object
      properties:
        approximateFulfillmentDelay:
          type: number
        salt:
          type: number
        metadata:
          type: string
      required:
        - approximateFulfillmentDelay
    FeeInfo:
      type: object
      properties:
        total:
          type: string
        details:
          $ref: '#/components/schemas/FeeDetails'
        approximateUsdValue:
          type: number
          description: USD approximate value of the transaction fee
      required:
        - total
        - details
    TxQuote:
      type: object
      properties:
        allowanceTarget:
          type: string
        allowanceValue:
          type: string
      required:
        - allowanceTarget
    SrcChainTokenInResponseType:
      type: object
      properties:
        address:
          type: string
        name:
          type: string
        symbol:
          type: string
        decimals:
          type: integer
        amount:
          type: string
        chainId:
          type: number
        approximateOperatingExpense:
          type: string
        mutatedWithOperatingExpense:
          type: boolean
        approximateUsdValue:
          type: number
        originApproximateUsdValue:
          type: number
      required:
        - address
        - name
        - symbol
        - decimals
        - amount
        - chainId
        - approximateOperatingExpense
        - mutatedWithOperatingExpense
        - approximateUsdValue
        - originApproximateUsdValue
    SrcChainTokenOutResponseType:
      type: object
      properties:
        address:
          type: string
        name:
          type: string
        symbol:
          type: string
        decimals:
          type: integer
        amount:
          type: string
        chainId:
          type: number
        maxRefundAmount:
          type: string
        approximateUsdValue:
          type: number
      required:
        - address
        - name
        - symbol
        - decimals
        - amount
        - chainId
        - maxRefundAmount
        - approximateUsdValue
    DstChainTokenOutResponseType:
      type: object
      properties:
        address:
          type: string
        name:
          type: string
        symbol:
          type: string
        decimals:
          type: integer
        amount:
          type: string
        chainId:
          type: number
        recommendedAmount:
          type: string
        withoutAdditionalTakerRewardsAmount:
          type: string
        withoutAdditionalTakerRewardsApproximateUsdValue:
          type: number
        approximateUsdValue:
          type: number
        recommendedApproximateUsdValue:
          type: number
        maxTheoreticalAmount:
          type: string
        maxTheoreticalApproximateUsdValue:
          type: number
      required:
        - address
        - name
        - symbol
        - decimals
        - amount
        - chainId
        - recommendedAmount
        - maxTheoreticalAmount
    CostsDetailsProperty:
      type: object
      properties:
        chain:
          type: string
        tokenIn:
          type: string
        tokenOut:
          type: string
        amountIn:
          type: string
        amountOut:
          type: string
        type:
          type: string
        payload:
          $ref: '#/components/schemas/Payload'
      required:
        - chain
        - tokenIn
        - tokenOut
        - amountIn
        - amountOut
        - type
    FeeDetails:
      type: object
      properties:
        giveOrderState:
          type: string
        giveOrderWallet:
          type: string
        nonceMaster:
          type: string
        txFee:
          type: string
        priorityFee:
          type: string
        gasLimit:
          type: string
        gasPrice:
          type: string
        baseFee:
          type: string
        maxFeePerGas:
          type: string
        maxPriorityFeePerGas:
          type: string
    Payload:
      type: object
      properties:
        feeAmount:
          type: string
        feeBps:
          type: string
        amountOutBeforeCorrection:
          type: string
        estimatedVolatilityBps:
          type: string
        actualFeeAmount:
          type: string
        actualFeeBps:
          type: string
        subsidyAmount:
          type: string
        feeApproximateUsdValue:
          type: string
        additionalMarginAmount:
          type: string
        additionalMarginBps:
          type: string

````